<template>
  <div class="dashboard-page-container pb-5">
    <h1 class="page-title">Change Password</h1>
    <div class="mt-4">
      <div class="row">
        <div class="col-sm-12 col-md-6">
          <div class="card card-setting">
            <form @submit.prevent="submitForm">
              <div class="py-5 px-2">
                <!-- <p class="fw-bold">Set Transaction PIN</p> -->
                <!-- <p>
                Change your current ATM Card PIN to a <br />
                new PIN by starting with the old PIN
              </p> -->
                <div class="form-input mb-3">
                  <label> Old Password </label>
                  <input
                    type="password"
                    class="form-control"
                    placeholder="Password"
                    v-model="form.oldPassword"
                    v-validate="'required'"
                    name="Old Password"
                  />
                  <div
                    v-show="verrors.has('Old Password')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Old Password') }}
                  </div>
                </div>
                <div class="form-input mb-3">
                  <label> New Password </label>
                  <input
                    type="password"
                    class="form-control"
                    placeholder="Password"
                    v-model="form.newPassword"
                    v-validate="'required'"
                    name="New Password"
                    ref="password"
                  />
                  <div
                    v-show="verrors.has('New Password')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('New Password') }}
                  </div>
                </div>
                <div class="form-input mb-3">
                  <label> Confirm Password </label>
                  <input
                    type="password"
                    class="form-control"
                    id="formPassword"
                    placeholder="Password"
                    v-model="form.confirmPassword"
                    v-validate="'required|confirmed:password'"
                    name="Confirm Password"
                  />
                  <div
                    v-show="verrors.has('Confirm Password')"
                    class="invalid-feedback"
                  >
                    {{ verrors.first('Confirm Password') }}
                  </div>
                </div>
                <div class="pin-input-container mt-3">
                  <!-- <p class="text-muted fw-bold">Confirm Pin</p> -->
                  <!-- <PincodeInput v-model="form.pinConfirm" placeholder="0" /> -->
                </div>
                <div class="mt-3">
                  <!-- <button class="btn btn-primary btn-lg h6 float-end px-4">
                    Save
                  </button> -->

                  <vs-button
                    type="submit"
                    :loading="form.active"
                    primary
                    class="px-4 py-1"
                  >
                    Save
                  </vs-button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      class="modal fade"
      id="PaymentSuccessModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img src="@/assets/images/transfer-success-icon.png" />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">
                Password changed Successful!
              </h3>

              <p class="text-muted my-2 px-3">
                Your Password has been changed. You can start using the new
                Password
              </p>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    type="button"
                    @click="logOut()"
                    data-bs-dismiss="modal"
                    style="font-size: 14px"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// import TransferBetweenAccounts from '@/assets/icons/transfer-between-accounts.svg?inline'
// import TransferToCorebankAccount from '@/assets/icons/transfer-to-corebank-account.svg?inline'
// import TransferToOtherBanks from '@/assets/icons/transfer-to-other-banks.svg?inline'

export default {
  layout: 'dashboard',
  components: {},
  data: () => ({
    form: {
      code: '',
      newCode: '',
      pinConfirm: '',
      active: false,
    },
  }),
  methods: {
    logOut() {
      localStorage.removeItem('core-bank-client-v1')
      this.$store.commit('auth/LOGOUT')
      localStorage.removeItem('core-bank-client-v1')
    },
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      const data = {
        ...this.form,
      }
      this.form.active = true

      this.$axios
        .patch('/auth/change-password', data)
        .then(({ data }) => {
          console.log(data)
          this.form.active = false
          // eslint-disable-next-line
          const modal = new bootstrap.Modal(
            document.getElementById('PaymentSuccessModal'),
            {}
          )
          modal.show()
          this.openNotification('top-left', 'success', data.message)
          setTimeout(() => {
            this.logOut()
          }, 1000)
        })
        .catch((error) => {
          // console.log(error)
          this.form.active = false
          if (
            error.response.status === 404 ||
            error.response.status === 400 ||
            error.response.status === 401 ||
            error.response.status === 403 ||
            error.response.status === 406 ||
            error.response.status === 409
          ) {
            // console.log(error.response.data.message)
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          } else {
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          }
        })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-page-container {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
  .card-setting .nav-link {
    border: none;
    color: #000;
    font-weight: bold;
    background: none;
    border-radius: 0;
    margin: 0 5px;
    &.active {
      border-bottom: 3px solid $primary;
      color: #000;
      font-weight: bold;
      background: none;
      border-radius: 0;
    }
  }
}
.vue-pincode-input {
  max-width: 45px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
}
</style>
